# 2020-09-08 Triage Log

See the [README](README.md) for details on how this log was gathered.

A few small compile-time regressions this week. The first was
[#70793](https://github.com/rust-lang/rust/pull/70793), which added some
specializations to the standard library in order to increase runtime
performance. The second was
[#73996](https://github.com/rust-lang/rust/pull/73996), which adds an option to
the diagnostics code to print only the names of types and traits when they are
unique instead of the whole path. The third was
[#75200](https://github.com/rust-lang/rust/pull/75200), which refactored part
of `BTreeMap` to avoid aliasing mutable references.

Triage done by @ecstaticmorse.
Revision range: [d927e5a655809b6b20501889e093c085d6ffe6f7..35fc8359868e65a0970094f648ba87fce634e8c7](https://perf.rust-lang.org/?start=d927e5a655809b6b20501889e093c085d6ffe6f7&end=35fc8359868e65a0970094f648ba87fce634e8c7&absolute=false&stat=instructions%3Au)

3 Regressions, 0 Improvements, 0 of them in rollups.

#### Regressions

[#75200](https://github.com/rust-lang/rust/pull/75200)
- A small regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=c59199efca5856cdf810919fbf9b5bce32dc4523&end=70c5f6efc445963bbfa5dd53f81c245741eac8cb&stat=instructions:u)

[#73996](https://github.com/rust-lang/rust/pull/73996)
- A small regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=0d0f6b113047b2cf9afbde990cee30fd5b866469&end=af3c6e733a40e671550e0f0f5aeecaa13772ba56&stat=instructions:u)

[#70793](https://github.com/rust-lang/rust/pull/70793)
- A small regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=62dad457bc73804891c6ac9a31f90de19cbb59a3&end=0d0f6b113047b2cf9afbde990cee30fd5b866469&stat=instructions:u) for `check`, `debug` and `opt` benchmarks.
- However, an improvement in `doc` benchmarks, likely due to better optimized standard library.

#### Improvements

- None

#### Nags requiring follow up

- [#75200](https://github.com/rust-lang/rust/pull/75200)
