# 2021-06-22 Triage Log

A few small regressions on smaller benchmarks (e.g., helloworld), likely
centered around more IR being generated in a few cases.

Triage done by **@simulacrum**.
Revision range: [d192c80d2284ba6b5146bb3da586354c3762c72b..3912083821c5072f700a75589c8af6a9d3e20a21](https://perf.rust-lang.org/?start=d192c80d2284ba6b5146bb3da586354c3762c72b&end=3912083821c5072f700a75589c8af6a9d3e20a21&absolute=false&stat=instructions%3Au)

2 Regressions, 1 Improvements, 0 Mixed

1 of them in rollups

#### Regressions

Rollup of 6 pull requests [#86417](https://github.com/rust-lang/rust/issues/86417)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=149f4836dd6d9e789a26dca16dc034588866894e&end=a6bc43ea846ee568ef4e890d4ac2a4cc03475bfc&stat=instructions:u) (up to 2.0% on `incr-unchanged` builds of `helloworld-opt`)
- Not really clear what the cause here is, but the regression is concentrated on
  small benchmarks.

Change entry point to 🛡️ against 💥 💥-payloads [#86034](https://github.com/rust-lang/rust/issues/86034)
- Moderate regression in [instruction counts](https://perf.rust-lang.org/compare.html?start=29cd70d40722930e66a8b726fe58a7bd1d64a22b&end=6b354a13820a444f834a33365ae4a8d97d7d27ce&stat=instructions:u) (up to 4.5% on `incr-full` builds of `helloworld-opt`)
- Seems to be more code getting generated into binaries, leading to
  regressions on the smaller benchmarks.

#### Improvements

optimize Eq implementation for paths [#86179](https://github.com/rust-lang/rust/issues/86179)
- Moderate improvement in [instruction counts](https://perf.rust-lang.org/compare.html?start=8daad743c4bb941536860b4df20111cb71b8c777&end=9fef8d91b4a6c5bfe07c025c434f2d623ad83337&stat=instructions:u) (up to -3.3% on `incr-patched: println` builds of `cargo-opt`)
- Mostly wins on incremental benchmarks.

#### Nags requiring follow up

Backlog:

* Follow up on regression in [#85343](https://github.com/rust-lang/rust/pull/85343#issuecomment-856819536)
